## esl-MongooseIM.zip

=== Makefile ===
.PHONY: rel

RUN=./tools/silent_exec.sh "$@.log"
XEP_TOOL = tools/xep_tool
EBIN = ebin
DEVNODES = mim1 mim2 mim3 fed1 reg1
REBAR=./rebar3

# Top-level targets aka user interface

all: rel

clean:
	-$(REBAR) clean
	-rm -rf _build
	-rm -rf asngen
	-rm configure.out
	-rm rel/configure.vars.config

# REBAR_CT_EXTRA_ARGS comes from a test runner
ct:
	@(if [ "$(SUITE)" ]; \
		then $(RUN) $(REBAR) ct --dir test --suite $(SUITE) ; \
		else $(RUN) $(REBAR) ct $(REBAR_CT_EXTRA_ARGS); fi)

eunit:
	@$(RUN) $(REBAR) eunit $(REBAR_EUNIT_EXTRA_ARGS)

rel: certs configure.out rel/configure.vars.config
	. ./configure.out && $(REBAR) as prod release

shell: certs
	$(REBAR) shell

# Top-level targets' dependency chain

rock:
	@if [ "$(FILE)" ]; then elvis rock $(FILE);\
	elif [ "$(BRANCH)" ]; then tools/rock_changed.sh $(BRANCH); \
	else tools/rock_changed.sh; fi

## Don't allow these files to go out of sync!
configure.out rel/configure.vars.config:
	./tools/configure with-all without-jingle-sip

devrel: $(DEVNODES)

print_devnodes:
	@echo $(DEVNODES)

$(DEVNODES): certs configure.out rel/vars-toml.config
	@echo "building $@"
	(. ./configure.out && \
	DEVNODE=true $(RUN) $(REBAR) as $@ release)

maybe_clean_certs:
	if [ "$$SKIP_CERT_BUILD" != 1 ]; then \
		if ! openssl x509 -checkend 36000 -noout -in tools/ssl/ca/cacert.pem ; then \
			cd tools/ssl && make clean_certs; \
		fi \
	fi

certs: maybe_clean_certs
	if [ "$$SKIP_CERT_BUILD" = 1 ]; then \
		echo "Skip cert build"; \
	else \
		cd tools/ssl && make; \
	fi

xeplist:
	$(XEP_TOOL)/xep_tool.escript doap doc/mongooseim.doap
	$(XEP_TOOL)/xep_tool.escript json doc/supported-xeps.json
	$(XEP_TOOL)/xep_tool.escript markdown doc/user-guide/Supported-XEPs.md

install: configure.out rel
	@. ./configure.out && tools/install

elvis:
	$(REBAR) as lint lint

=== big_tests/Makefile ===
.PHONY: all test console compile
all: test

# user overridable
TESTSPEC ?= default.spec
PRESET   ?= all
CT_HOOKS ?=
PREPARE  ?= prepare
ADD_OPTS ?= -sasl sasl_error_logger false
TLS_DIST ?= false
REPO_DIR ?= ..
TEST_DIR ?= .
ABS_REPO_DIR = $(shell $(REPO_DIR)/tools/abs_dirpath.sh $(REPO_DIR))
ABS_TEST_DIR = $(shell $(REPO_DIR)/tools/abs_dirpath.sh $(TEST_DIR))
RUN = $(REPO_DIR)/tools/silent_exec.sh "$@.log"
REBAR = $(REPO_DIR)/rebar3

# autogenerated, not intended for overriding
DEPS_PATHS := $(addprefix $(REPO_DIR)/_build/test/lib/,$(addsuffix /ebin,$(DEPS)))

ifeq ($(TLS_DIST),true)
TLS_DIST_OPTS := -args_file vm.dist.args
else
TLS_DIST_OPTS :=
endif

COMMON_OPTS := -sname test -setcookie mongooseim -hidden \
               $(TLS_DIST_OPTS) \
               -env REPO_DIR "$(ABS_REPO_DIR)" \
               -env TEST_DIR "$(ABS_TEST_DIR)" \
               -pa `pwd`/_build/default/lib/*/ebin \
                   `pwd`/tests \
               $(DEPS_PATHS)

ifeq ($(shell uname), Linux)
SED := sed
else
SED := gsed
endif

test_clean: get-deps
	rm -rf tests/*.beam
	$(MAKE) test

cover_test_clean: get-deps
	rm -rf tests/*.beam
	$(MAKE) cover_test

quicktest: $(PREPARE)
	$(RUN) erl -hidden -noinput $(COMMON_OPTS) $(ADD_OPTS) \
			-s run_common_test main test=quick spec=$(TESTSPEC)

cover_quicktest: $(PREPARE)
	$(RUN) erl -noinput $(COMMON_OPTS) $(ADD_OPTS) \
			-s run_common_test main test=quick spec=$(TESTSPEC) cover=true

cover_test_preset: $(PREPARE)
	$(RUN) erl -noinput $(COMMON_OPTS) $(ADD_OPTS) \
			-s run_common_test main test=full spec=$(TESTSPEC) hooks=$(CT_HOOKS) \
			preset="$(PRESET)" cover=true

cover_test: $(PREPARE)
	$(RUN) erl -noinput $(COMMON_OPTS) $(ADD_OPTS) \
			-s run_common_test main test=full spec=$(TESTSPEC) cover=true

test_preset: $(PREPARE)
	$(RUN) erl -noinput $(COMMON_OPTS) $(ADD_OPTS) \
			-s run_common_test main test=full spec=$(TESTSPEC) hooks=$(CT_HOOKS) \
                        preset="$(PRESET)"

test: $(PREPARE)
	$(RUN) erl -noinput $(COMMON_OPTS) $(ADD_OPTS) \
			-s run_common_test main test=full spec=$(TESTSPEC)

prepare: mim_ct_rest compile vm.dist.args
	erlc -I_build/default/lib/exml/include \
		 run_common_test.erl
	mkdir -p ct_report

mim_ct_rest: \
	$(REPO_DIR)/test/mim_ct_rest.erl \
	$(REPO_DIR)/test/mim_ct_rest_handler.erl \
	$(REPO_DIR)/test/mim_ct_sup.erl
	cp $^ src/

vm.dist.args: vm.dist.args.in certs
	$(SED) -e 's%__PWD__%$(PWD)%g' $< > $@

certs: priv/ssl/cert.pem priv/ssl/key.pem priv/ssl/cacert.pem

priv/ssl/cert.pem priv/ssl/key.pem priv/ssl/cacert.pem: \
  $(REPO_DIR)/tools/ssl/mongooseim/cert.pem \
  $(REPO_DIR)/tools/ssl/mongooseim/key.pem \
  $(REPO_DIR)/tools/ssl/ca/cacert.pem
	mkdir -p $(@D)
	cp $^ $(@D)/
	cat priv/ssl/key.pem >> priv/ssl/cert.pem

console: $(PREPARE)
	erl $(COMMON_OPTS) $(ADD_OPTS) -s run_common_test init

compile: get-deps deps
	$(RUN) $(REBAR) compile

get-deps:
	$(RUN) $(REBAR) deps

clean:
	-@rm -rf _build
	-@rm priv/ssl/*
	-@rm -rf tests/*.beam > /dev/null 2>&1
	-@$(REBAR) clean > /dev/null 2>&1

# to compile esip.
# It should able to find stun.hrl. But searching paths are hardcoded
deps:
	ln -fs `pwd`/_build/default/lib deps

=== tools/ssl/Makefile ===
all: mongooseim/cert.pem mongooseim/key.pem \
  mongooseim/server.pem mongooseim/dh_server.pem \
  mongooseim/pubkey.pem mongooseim/privkey.pem \
  ca/cacert.pem ca/cakey.pem ca/index.txt ca/serial.txt \
  ca-clients/cacert.pem ca-clients/cakey.pem ca-clients/index.txt ca-clients/serial.txt
	chmod -R a+r mongooseim ca ca-clients

%/cacert.pem %/cakey.pem: openssl-%.cnf
	mkdir -p $(@D)
	openssl req -x509 -config $< -newkey rsa:2048 -sha256 -nodes \
	            -out $(@D)/cacert.pem -keyout $(@D)/cakey.pem -outform PEM

%/cert.csr %/key.pem: openssl-%.cnf
	mkdir -p $(@D)
	openssl req -config $< -newkey rsa:2048 -sha256 -nodes \
		-out $(@D)/cert.csr -keyout $(@D)/key.pem \
		-outform PEM

%/cert.pem: %/cert.csr openssl-ca.cnf ca/cacert.pem ca/cakey.pem | ca/index.txt ca/serial.txt
	yes | openssl ca -config openssl-ca.cnf -policy signing_policy \
		-extensions signing_req -out $@ -infiles $<

%/server.pem: %/cert.pem %/key.pem
	cat $^ > $@

%/pubkey.pem: %/cert.pem
	openssl x509 -pubkey -noout -in $< > $@

%/privkey.pem: %/key.pem
	openssl rsa -in $< -out $@

# About dsaparam argument
# It speeds up generation of dhparam
# Speed is useful for fake certificates
# https://security.stackexchange.com/questions/95178/diffie-hellman-parameters-still-calculating-after-24-hours
#
# Certs generated with -dsaparam don't work with our slapd container though.
# So, let's remove the option for now.
# https://bugs.launchpad.net/ubuntu/+source/openldap/+bug/1724285
%/dh_server.pem:
	openssl dhparam -outform PEM -out $@ 2048

%/index.txt:
	mkdir -p $(@D)
	touch $@

%/serial.txt:
	mkdir -p $(@D)
	echo 01 > $@

clean:
	rm -rf ca ca-clients mongooseim

clean_certs:
	rm -rf ca ca-clients
	ls -d mongooseim/* | grep -v dh_server.pem | xargs rm -f

=== tools/pkg/scripts/deb/debian/changelog ===
mongooseim (@VER@) unstable; urgency=low

  * New release

 -- Erlang Solutions <packages@erlang-solutions.com> @DATE@

=== tools/pkg/scripts/deb/debian/control ===
Source: mongooseim
Section: net
Priority: extra
Maintainer: Erlang Solutions <packages@erlang-solutions.com>
Build-Depends: debhelper (>= 8.0.0), git, make, zlib1g-dev, libssl-dev, unixodbc-dev, gcc, g++,  esl-erlang
Version: @VER@
Standards-Version: 3.9.2
Homepage: http://erlang-solutions.com
#Vcs-Git: git://git.debian.org/collab-maint/mongooseim.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/mongooseim.git;a=summary
Package: mongooseim
Architecture: @ARCH@
Description: distributed, fault-tolerant Jabber/XMPP server written in Erlang
 mongooseim is a distributed, fault-tolerant Jabber/XMPP server written in Erlang.
 Its features contain:
  - XMPP-compliant
  - Load balancing: can run in a cluster of machines
  - Fault-tolerance: database can be replicated and stored on multiple
    nodes (nodes can be added or replaced 'on the fly')
  - Virtual hosting: several virtual domains can be served using single mongooseim
    instance
  - SSL/TLS support
  - Service Discovery

=== tools/pkg/scripts/deb/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

binary:
	dh_testroot
	dh_prep
	dh_installdirs
	dh_auto_install
	dh_install
	dh_installdocs
	dh_installchangelogs
	dh_installexamples
	dh_installman
	dh_installcatalogs
	dh_installcron
	dh_installdebconf
	dh_installemacsen
	dh_installifupdown
	dh_installinfo
	dh_installinit
	dh_installmenu
	dh_installmime
	dh_installmodules
	dh_installlogcheck
	dh_installlogrotate
	dh_installpam
	dh_installppp
	dh_installudev
	dh_installwm
	dh_installxfonts
	dh_bugfiles
	dh_lintian
	dh_gconf
	dh_icons
	dh_perl
	dh_usrlocal
	dh_link
	dh_compress
	dh_fixperms
	dh_strip
	dh_makeshlibs
	dh_shlibdeps
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

%:
	dh $@
override_dh_auto_test:
